"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VNode = exports.VNodeMeta = void 0;
var tslib_1 = require("tslib");
var declarative_shadow_dom_polyfill_1 = require("declarative-shadow-dom-polyfill");
var web_utility_1 = require("web-utility");
var VNodeMeta = /** @class */ (function () {
    function VNodeMeta() {
        this.children = [];
    }
    return VNodeMeta;
}());
exports.VNodeMeta = VNodeMeta;
var VNode = /** @class */ (function (_super) {
    tslib_1.__extends(VNode, _super);
    function VNode(_b) {
        var e_1, _c, _d, e_2, _e;
        var _this = this;
        var children = _b.children, meta = tslib_1.__rest(_b, ["children"]);
        _this = _super.call(this) || this;
        Object.assign(_this, meta);
        try {
            for (var _f = tslib_1.__values(children || []), _g = _f.next(); !_g.done; _g = _f.next()) {
                var vNode = _g.value;
                (_d = _this.children).push.apply(_d, tslib_1.__spreadArray([], tslib_1.__read((_a.isFragment(vNode) ? vNode.children || [] : [vNode])), false));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _h = tslib_1.__values(_this.children), _j = _h.next(); !_j.done; _j = _h.next()) {
                var child = _j.value;
                child.parent = _this;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_j && !_j.done && (_e = _h.return)) _e.call(_h);
            }
            finally { if (e_2) throw e_2.error; }
        }
        var tagName = meta.tagName, is = meta.is, props = meta.props;
        if (!tagName && !(props === null || props === void 0 ? void 0 : props.className) && !is)
            return _this;
        _this.selector = [
            tagName === null || tagName === void 0 ? void 0 : tagName.toLowerCase(),
            (props === null || props === void 0 ? void 0 : props.className) && ".".concat(props.className.trim().replace(/\s+/, '.')),
            is && "[is=\"".concat(is, "\"]")
        ]
            .filter(Boolean)
            .join('');
        return _this;
    }
    VNode.prototype.walkUp = function () {
        var current;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    current = this;
                    _b.label = 1;
                case 1:
                    if (!(current = current.parent)) return [3 /*break*/, 3];
                    return [4 /*yield*/, current];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 1];
                case 3: return [2 /*return*/];
            }
        });
    };
    VNode.prototype.namespaceOf = function (tagName) {
        var e_3, _b;
        if (web_utility_1.XMLNamespace[tagName])
            return web_utility_1.XMLNamespace[tagName];
        try {
            for (var _c = tslib_1.__values(this.walkUp()), _d = _c.next(); !_d.done; _d = _c.next()) {
                var namespace = _d.value.namespace;
                if (namespace)
                    return namespace;
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return web_utility_1.XMLNamespace.html;
    };
    VNode.prototype.createDOM = function (document) {
        if (document === void 0) { document = globalThis.document; }
        var _b = this, tagName = _b.tagName, is = _b.is, text = _b.text;
        return (this.node = text
            ? document.createTextNode(text)
            : !tagName
                ? document.createDocumentFragment()
                : document.createElementNS((this.namespace || (this.namespace = this.namespaceOf(tagName))), tagName, {
                    is: is
                }));
    };
    VNode.prototype.toJSON = function () {
        var _b = this, key = _b.key, text = _b.text, selector = _b.selector, namespace = _b.namespace, tagName = _b.tagName, is = _b.is, props = _b.props, style = _b.style, children = _b.children;
        return JSON.parse(JSON.stringify({ key: key, text: text, selector: selector, namespace: namespace, tagName: tagName, is: is, props: props, style: style, children: children }));
    };
    VNode.prototype.generateElementXML = function () {
        var _b, tagName, props, style, children, node, body, shadowRoots, innerHTML, restProps, _c, _d, _e, _i, key, _f, _g, _h, _j, key, children_1, children_1_1, child, e_4_1;
        var e_4, _k;
        return tslib_1.__generator(this, function (_l) {
            switch (_l.label) {
                case 0:
                    _b = this, tagName = _b.tagName, props = _b.props, style = _b.style, children = _b.children, node = _b.node;
                    if (!(tagName.includes('-') && (0, web_utility_1.elementTypeOf)(tagName) === 'html')) return [3 /*break*/, 2];
                    body = ((node === null || node === void 0 ? void 0 : node.ownerDocument) || document).implementation.createHTMLDocument().body;
                    body.innerHTML = "<".concat(tagName, "></").concat(tagName, ">");
                    shadowRoots = tslib_1.__spreadArray([], tslib_1.__read((0, declarative_shadow_dom_polyfill_1.findShadowRoots)(body)), false);
                    return [4 /*yield*/, body.getHTML({ serializableShadowRoots: true, shadowRoots: shadowRoots })];
                case 1:
                    _l.sent();
                    return [3 /*break*/, 29];
                case 2:
                    innerHTML = props.innerHTML, restProps = tslib_1.__rest(props, ["innerHTML"]);
                    return [4 /*yield*/, "<".concat(tagName)];
                case 3:
                    _l.sent();
                    _c = restProps;
                    _d = [];
                    for (_e in _c)
                        _d.push(_e);
                    _i = 0;
                    _l.label = 4;
                case 4:
                    if (!(_i < _d.length)) return [3 /*break*/, 7];
                    _e = _d[_i];
                    if (!(_e in _c)) return [3 /*break*/, 6];
                    key = _e;
                    return [4 /*yield*/, " ".concat(_a.propsMap[key] || key, "=\"").concat(restProps[key], "\"")];
                case 5:
                    _l.sent();
                    _l.label = 6;
                case 6:
                    _i++;
                    return [3 /*break*/, 4];
                case 7:
                    if (!style) return [3 /*break*/, 14];
                    return [4 /*yield*/, " style=\""];
                case 8:
                    _l.sent();
                    _f = style;
                    _g = [];
                    for (_h in _f)
                        _g.push(_h);
                    _j = 0;
                    _l.label = 9;
                case 9:
                    if (!(_j < _g.length)) return [3 /*break*/, 12];
                    _h = _g[_j];
                    if (!(_h in _f)) return [3 /*break*/, 11];
                    key = _h;
                    return [4 /*yield*/, "".concat((0, web_utility_1.toHyphenCase)(key), ":").concat(style[key], ";")];
                case 10:
                    _l.sent();
                    _l.label = 11;
                case 11:
                    _j++;
                    return [3 /*break*/, 9];
                case 12: return [4 /*yield*/, "\""];
                case 13:
                    _l.sent();
                    _l.label = 14;
                case 14:
                    if (!innerHTML) return [3 /*break*/, 16];
                    return [4 /*yield*/, ">".concat(innerHTML, "</").concat(tagName, ">")];
                case 15:
                    _l.sent();
                    return [3 /*break*/, 29];
                case 16:
                    if (!children[0]) return [3 /*break*/, 27];
                    return [4 /*yield*/, '>'];
                case 17:
                    _l.sent();
                    _l.label = 18;
                case 18:
                    _l.trys.push([18, 23, 24, 25]);
                    children_1 = tslib_1.__values(children), children_1_1 = children_1.next();
                    _l.label = 19;
                case 19:
                    if (!!children_1_1.done) return [3 /*break*/, 22];
                    child = children_1_1.value;
                    return [5 /*yield**/, tslib_1.__values(child.generateXML())];
                case 20:
                    _l.sent();
                    _l.label = 21;
                case 21:
                    children_1_1 = children_1.next();
                    return [3 /*break*/, 19];
                case 22: return [3 /*break*/, 25];
                case 23:
                    e_4_1 = _l.sent();
                    e_4 = { error: e_4_1 };
                    return [3 /*break*/, 25];
                case 24:
                    try {
                        if (children_1_1 && !children_1_1.done && (_k = children_1.return)) _k.call(children_1);
                    }
                    finally { if (e_4) throw e_4.error; }
                    return [7 /*endfinally*/];
                case 25: return [4 /*yield*/, "</".concat(tagName, ">")];
                case 26:
                    _l.sent();
                    return [3 /*break*/, 29];
                case 27: return [4 /*yield*/, tagName === 'script' ? '></script>' : ' />'];
                case 28:
                    _l.sent();
                    _l.label = 29;
                case 29: return [2 /*return*/];
            }
        });
    };
    VNode.prototype.generateXML = function () {
        var mode;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!_a.isFragment(this)) return [3 /*break*/, 5];
                    return [4 /*yield*/, '<template'];
                case 1:
                    _b.sent();
                    mode = (this.node || {}).mode;
                    if (!mode) return [3 /*break*/, 3];
                    return [4 /*yield*/, " shadowrootmode=\"".concat(mode, "\"")];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3: return [4 /*yield*/, '>'];
                case 4:
                    _b.sent();
                    return [3 /*break*/, 9];
                case 5:
                    if (!(this.text != null)) return [3 /*break*/, 7];
                    return [4 /*yield*/, this.text];
                case 6:
                    _b.sent();
                    return [3 /*break*/, 9];
                case 7: return [5 /*yield**/, tslib_1.__values(this.generateElementXML())];
                case 8:
                    _b.sent();
                    _b.label = 9;
                case 9: return [2 /*return*/];
            }
        });
    };
    VNode.isFragment = function (_b) {
        var key = _b.key, node = _b.node, children = _b.children, rest = tslib_1.__rest(_b, ["key", "node", "children"]);
        for (var key_1 in rest)
            if (!(0, web_utility_1.isEmpty)(rest[key_1]))
                return false;
        return true;
    };
    VNode.fromDOM = function (node) {
        var _this = this;
        if (node instanceof Text)
            return new _a({ node: node, text: node.nodeValue });
        if (!(node instanceof Element))
            return new _a({ node: node });
        var _b = node, namespaceURI = _b.namespaceURI, tagName = _b.tagName, attributes = _b.attributes, style = _b.style, childNodes = _b.childNodes;
        var vNode = {
            node: node,
            namespace: namespaceURI,
            tagName: tagName.toLowerCase(),
            is: node.getAttribute('is')
        };
        var props = Array.from(attributes, function (_b) {
            var name = _b.name, value = _b.value;
            return name !== 'style' && [_this.attrsMap[name] || name, value];
        }).filter(Boolean);
        if (props[0])
            vNode.props = Object.fromEntries(props);
        var styles = Array.from(style, function (key) { return [key, style[key]]; });
        if (styles[0])
            vNode.style = Object.fromEntries(styles);
        var children = Array.from(childNodes, function (node) { return _a.fromDOM(node); });
        if (children[0])
            vNode.children = children;
        return new _a(vNode);
    };
    var _a;
    _a = VNode;
    VNode.propsMap = {
        className: 'class',
        htmlFor: 'for'
    };
    VNode.attrsMap = Object.fromEntries(Object.entries(_a.propsMap).map(function (item) { return item.reverse(); }));
    return VNode;
}(VNodeMeta));
exports.VNode = VNode;
